<?php
define('ERR_UNKNOWN', 1);
define('ERR_FILEHOST_EXIST', 2);
define('ERR_INVALID_FILEHOST', 3);
define('LOGIN_FAIL', 4);
define('USER_IS_FREE', 5);
define('USER_IS_PREMIUM', 6);
define('ERR_UPATE_FAIL', 7);
define('ERR_BROKEN_LINK', 102);
define('ERR_FILE_NO_EXIST', 114);
define('ERR_REQUIRED_PREMIUM', 115);
define('ERR_NOT_SUPPORT_TYPE', 116);
define('ERR_REQUIRED_ACCOUNT', 124);
define('ERR_TRY_IT_LATER', 125);
define('DOWNLOAD_STATION_USER_AGENT', "Synology Download Station");
define('DOWNLOAD_URL', 'downloadurl');
define('DOWNLOAD_FILENAME', 'filename');
define('DOWNLOAD_ISQUERYAGAIN', 'isqueryagain');
define('DOWNLOAD_ISPARALLELDOWNLOAD', 'isparalleldownload');
define('DOWNLOAD_ERROR', 'error');

class LinkSnappyMultiHost
{
    private $url;
    private $username;
    private $password;
    private $hostInfo;
    private $cookiePath = '/tmp/lseplugin.cookie';
    private $userLoginApi = 'https://linksnappy.com/api/AUTHENTICATE';
    private $userInfoApi = 'https://linksnappy.com/api/USERDETAILS';
    private $linkgenApi = 'https://linksnappy.com/api/linkgen';
    private $linkgenCacheApi = 'https://linksnappy.com/api/CACHEDLSTATUS';


    public function __construct($url, $username, $password, $hostInfo) {
        $this->url = $url;
        $this->username = rawurlencode(trim($username));
        $this->password = rawurlencode(trim($password));
        $this->hostInfo = $hostInfo;
    }

    public function CacheDLChecker($hash){
        $retr = $this -> ReqPage($this -> linkgenCacheApi . "?id=$hash");
        $cacheStatus = json_decode($retr, true);
        if($cacheStatus['status'] == "OK"){
            if($cacheStatus['return']['percent'] < 100){
                sleep(5);
                return $this -> CacheDLChecker($hash);
            }else{
                return true;
            }
        }else{
            return false;
        }
    }
    public function GetDownloadInfo() {
        if($this -> Verify(false) == USER_IS_PREMIUM){
            $retr = $this -> ReqPage($this -> linkgenApi, 'genLinks={"link" : "'.$this -> url.'"}');

            if($retr == 'error'){
                return array(
                    DOWNLOAD_ERROR           => ERR_UNKNOWN
                );
            }
            $linkGen = json_decode($retr, true);
            if(isset($linkGen['status']) && $linkGen['status'] == 'ERROR'){
                $this -> Verify(true);
                return array(
                    DOWNLOAD_ERROR           => ERR_REQUIRED_PREMIUM
                );
            }else{
                $linkData = $linkGen['links'][0];

                if($linkData['status'] == "OK"){
                    if(isset($linkData['cacheDL'])){
                        if(!$this -> CacheDLChecker($linkData['hash'])){
                            return array(
                                DOWNLOAD_ERROR           => ERR_TRY_IT_LATER
                            );
                        }
                    }
                    return array(
                        DOWNLOAD_FILENAME           => $linkData['filename'],
                        DOWNLOAD_URL                => $linkData['generated'],
                        DOWNLOAD_ISPARALLELDOWNLOAD => true,
                    );
                }else{
                    if(strpos($linkData['error'],'Sorry this filehost is not supported yet') !== FALSE){
                        return array(
                            DOWNLOAD_ERROR           => ERR_NOT_SUPPORT_TYPE
                        );
                    }
                    elseif(strpos($linkData['error'],'087') !== FALSE){
                        return array(
                            DOWNLOAD_ERROR           => ERR_TRY_IT_LATER
                        );
                    }
                    elseif(strpos($linkData['error'],'No server available for this filehost') !== FALSE){
                        return array(
                            DOWNLOAD_ERROR           => ERR_TRY_IT_LATER
                        );
                    }
                    else{
                        return array(
                            DOWNLOAD_ERROR           => ERR_FILE_NO_EXIST
                        );
                    }

                }
            }

        }
        else{
            return array(
                DOWNLOAD_ERROR           => ERR_REQUIRED_PREMIUM
            );
        }
    }

    public function Verify($removeCookie) {

        if($removeCookie && file_exists($this -> cookiePath)){
            unlink($this -> cookiePath);
        }

        $retr = $this -> ReqPage($this -> userInfoApi);

        if(strpos($retr,'"status":"OK"') !== false){
            $userDetails = json_decode($retr, true);
            $userDetails = $userDetails['return'];
            if($userDetails['accountType'] == 'elite'){
                return USER_IS_PREMIUM;
            }else{
                return USER_IS_FREE;
            }
        }else{
            $retr = $this -> ReqPage($this -> userLoginApi . "?username={$this -> username}&password={$this -> password}");

            if(strpos($retr,'"status":"OK"') !== false){
                return USER_IS_PREMIUM;
            }else{
                return LOGIN_FAIL;
            }
        }

    }

    private function ReqPage($url, $post = false, $timeout = 30)
    {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_HEADER, FALSE);
        curl_setopt($ch, CURLOPT_NOBODY, FALSE);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, true);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2);
        curl_setopt($ch, CURLOPT_COOKIEJAR, $this-> cookiePath);
        curl_setopt($ch, CURLOPT_COOKIEFILE, $this-> cookiePath);
        curl_setopt($ch, CURLOPT_USERAGENT,DOWNLOAD_STATION_USER_AGENT);

        if ($timeout) {
            curl_setopt($ch, CURLOPT_TIMEOUT, $timeout);
        }
        if ($post) {
            curl_setopt($ch, CURLOPT_POST, 1);
            curl_setopt($ch, CURLOPT_POSTFIELDS, $post);
        }

        $urlPage = curl_exec($ch);
        if (curl_errno($ch)) {
            return "error";
        }
        curl_close($ch);

        return ($urlPage);
    }
}
